module DataPath(IsFull,IsEmpty,i,Op,PCCond,WriteData,PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zwe,nwe,cwe,iset,ireset,eset,ereset,PCWriteCond,AluA,AluB,PCSrc,RReg,RegDst,RegData,AluOp,reset,Enq,Deq,CLK);
	
	output	[15:0]	Op;
	output		i,IsFull,IsEmpty;

  input PCCond,WriteData,PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zwe,nwe,cwe,iset,ireset,eset,ereset,Enq,Deq,PCWriteCond,CLK,reset;
	input [1:0]AluA,AluB,PCSrc,RReg,RegDst,RegData,AluOp;

	wire [15:0] WData,ALU,ALUOut,IR,MDR,RR1,RR2,MemInData,MemOut,QOut,QSize,A,B,SExtended;
	wire [11:0] PCin,PCout,MemAddr;
	wire [3:0]	RR1Addr,WRAddr;
	wire [1:0] AluA,AluB,PCSrc,RReg,RegDst,RegData;
	wire PCWrite,IorD,MemWrite,MemRead,IRWrite,RegWrite,zero,carry,negative,n,c,z,e,i,zwe,nwe,cwe,JCond,Enq,Deq,eset1,eset2;

	assign Op = IR;
	assign negative = ALU[15];
	
	Reg_12bit PC(PCin, PCout, PCW, reset, CLK);

	MUX4x1_12bit PCSelect(PCSrc, ALU[11:0], RR1[11:0], IR[11:0], 12'b0, PCin);
	MUX2x1_12bit AddrSelect(IorD, PCout, IR[11:0], MemAddr);
	
	Memory MainMem(MemAddr,MemInData,MemOut,MemWrite,CLK);
	Reg_16bit_a InstReg(MemOut, IR, IRWrite, 1'b0, CLK);
	Reg_16bit_b MDReg(MemOut, MDR, 1'b1, reset, CLK);

	and cond_check(Cond,PCWriteCond,JCond);
	or	PCSource_Or(PCW,PCWrite,Cond,Cond2);
	and Cond2_check(Cond2,i,PCCond);

	MUX2x1_16bit MemWriteData(WriteData, RR1, QOut, MemInData);

	MUX4x1_4bit RR1Select(RReg, 4'b0, 4'b1111, IR[7:4], 4'b0, RR1Addr);
	MUX4x1_4bit WRSelect(RegDst, 4'b0, 4'b1111, IR[11:8], 4'b0, WRAddr);
	MUX4x1_16bit RDSelect(RegData, MDR, {4'b0000,PCout}, ALUOut, QSize, WData);
	
	RegFile_16bit RegFile(RR1Addr, RR1, IR[3:0], RR2, WRAddr, WData, RegWrite, CLK);
	
	MUX4x1_16bit AluSrcA(AluA, {4'b0000,PCout}, RR1, 16'b0, 16'b0, A); //Not Completed
	MUX4x1_16bit AluSrcB(AluB, RR2, 16'b1, 16'b0, SExtended, B);
	
	SignExtend_16bit SignExtend(IR[7:0], SExtended);
	
	ALU_mips Alu(A, B, AluOp, ALU, zero, carry);
	Reg_16bit AluOutReg(ALU, ALUOut, 1'b1, reset, CLK);

	Reg_1bit CarryReg(carry, c, cwe, reset, CLK);
	Reg_1bit ZeroReg(zero, z, zwe, reset, CLK);
	Reg_1bit NegativeReg(negative, n, nwe, reset, CLK);

	Reg_1bit_sr InterruptReg(i, iset, ireset, CLK);		
	
	or ESET_OR(eset2,eset,eset1);
	Reg_1bit_sr ErrorReg(e, eset2, ereset, CLK);

	Cond_Detect CD(JCond,IR[11:8],c,z,n,e);

	Q Queue(QOut,QSize,IsFull,IsEmpty,eset1,MDR,Enq,Deq,CLK);

	initial
	begin		
		InstReg.Data = 16'h4000;
	end

endmodule