//Memmory unit
//Kamyar Rafati & Naeem Esfahani

module Memory(address,ind,outd,we,clk);
	input[15:0]		ind;
	input[11:0]		address;
	input		we,clk;
	output[15:0]	outd;
	reg[15:0]		memory[4095:0];
	reg[15:0]		outd;
	wire			we_clk;
	wire			re_clk;


	assign we_clk = we & clk;

	initial
		$readmemb("mem.dat", memory);

// loads a hex code from file mem.dat to the memory, the format for the file 
//is as follows: you specify a 3-bit hex address at each line then 8 bit instruction 
//is followed(start at address 000)

	always @ (address)
	begin
		outd = memory[address];
	end

	always @(negedge we_clk)
	begin
		memory[address] = ind;
	end
endmodule



